<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_request_practice".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanRequestPractice".
 *
 * Columns in table "scan_request_practice" available as properties of the model,
 * followed by relations of table "scan_request_practice" available as properties of the model.
 *
 * @property integer $id
 * @property integer $scan_request_id
 * @property integer $primary_specialty_id
 * @property integer $practice_id
 * @property string $practice_name
 * @property string $address
 * @property string $zipcode
 * @property string $city
 * @property string $state_abbreviation
 * @property double $latitude
 * @property double $longitude
 * @property string $state
 * @property string $phone_number
 * @property string $website
 *
 * @property ScanRequestProvider[] $scanRequestProviders
 * @property ScanResultPractice[] $scanResultPractices
 * @property ScanStatsPractice[] $scanStatsPractices
 */
abstract class BaseScanRequestPractice extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_request_practice';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanRequestPractice|ScanRequestPractices', $n);
    }

    public static function representingColumn()
    {
        return 'practice_name';
    }

    public function rules()
    {
        return array(
            array('scan_request_id', 'required'),
            array('scan_request_id, primary_specialty_id, practice_id', 'numerical', 'integerOnly'=>true),
            array('latitude, longitude', 'numerical'),
            array('practice_name, address, website', 'length', 'max'=>255),
            array('zipcode, state_abbreviation', 'length', 'max'=>5),
            array('city, state', 'length', 'max'=>50),
            array('phone_number', 'length', 'max'=>45),
            array('primary_specialty_id, practice_id, practice_name, address, zipcode, city, state_abbreviation, latitude, longitude, state, phone_number, website', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, scan_request_id, primary_specialty_id, practice_id, practice_name, address, zipcode, city, state_abbreviation, latitude, longitude, state, phone_number, website', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'scanRequest' => array(self::BELONGS_TO, 'ScanRequest', 'scan_request_id'),
            'scanRequestProviders' => array(self::HAS_MANY, 'ScanRequestProvider', 'scan_request_practice_id'),
            'scanResultPractices' => array(self::HAS_MANY, 'ScanResultPractice', 'scan_request_practice_id'),
            'scanStatsPractices' => array(self::HAS_MANY, 'ScanStatsPractice', 'scan_input_practice_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'scan_request_id' => Yii::t('app', 'Scan Request'),
            'primary_specialty_id' => Yii::t('app', 'Primary Specialty'),
            'practice_id' => Yii::t('app', 'Practice'),
            'practice_name' => Yii::t('app', 'Practice Name'),
            'address' => Yii::t('app', 'Address'),
            'zipcode' => Yii::t('app', 'Zipcode'),
            'city' => Yii::t('app', 'City'),
            'state_abbreviation' => Yii::t('app', 'State Abbreviation'),
            'latitude' => Yii::t('app', 'Latitude'),
            'longitude' => Yii::t('app', 'Longitude'),
            'state' => Yii::t('app', 'State'),
            'phone_number' => Yii::t('app', 'Phone Number'),
            'website' => Yii::t('app', 'Website'),
            'scanRequestProviders' => null,
            'scanResultPractices' => null,
            'scanStatsPractices' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('scan_request_id', $this->scan_request_id);
        $criteria->compare('primary_specialty_id', $this->primary_specialty_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('practice_name', $this->practice_name, true);
        $criteria->compare('address', $this->address, true);
        $criteria->compare('zipcode', $this->zipcode, true);
        $criteria->compare('city', $this->city, true);
        $criteria->compare('state_abbreviation', $this->state_abbreviation, true);
        $criteria->compare('latitude', $this->latitude);
        $criteria->compare('longitude', $this->longitude);
        $criteria->compare('state', $this->state, true);
        $criteria->compare('phone_number', $this->phone_number, true);
        $criteria->compare('website', $this->website, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
